import { Span } from "../diagnostics.ts";

export type Stmt = {
    kind: StmtKind;
};

export type StmtKind =
    | { tag: "error" }
    | { tag: "assign" } & AssignStmt
    | { tag: "fake_read" } & FakeReadStmt
    | { tag: "deinit" } & DeinitStmt
    | { tag: "live" } & LiveStmt
    | { tag: "dead" } & DeadStmt
    | { tag: "mention" } & MentionStmt;

export type AssignStmt = { place: Place; rval: RVal };
export type FakeReadStmt = { place: Place };
export type DeinitStmt = { place: Place };
export type LiveStmt = { local: Local };
export type DeadStmt = { local: Local };
export type MentionStmt = { place: Place };

export type Place = {
    local: Local;
    proj: ProjElem[];
};

// https://doc.rust-lang.org/beta/nightly-rustc/rustc_middle/mir/type.PlaceElem.html
export type ProjElem =
    | { tag: "deref" }
    | { tag: "repeat" }
    | { tag: "field"; fieldIdx: number }
    | { tag: "index": local: Local }
    | { tag:  }

// https://doc.rust-lang.org/beta/nightly-rustc/rustc_middle/mir/enum.Rvalue.html
export type RVal = {};

export type Local = {};

